// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package pb

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ArticlesDBServiceClient is the client API for ArticlesDBService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ArticlesDBServiceClient interface {
	GetArticles(ctx context.Context, in *GetArticlesRequest, opts ...grpc.CallOption) (ArticlesDBService_GetArticlesClient, error)
	GetArticle(ctx context.Context, in *GetArticleRequest, opts ...grpc.CallOption) (*GetArticleResponse, error)
	CreateArticle(ctx context.Context, in *CreateArticleRequest, opts ...grpc.CallOption) (*CreateArticleResponse, error)
	DeleteArticle(ctx context.Context, in *DeleteArticleRequest, opts ...grpc.CallOption) (*DeleteArticleResponse, error)
	UpdateArticle(ctx context.Context, in *UpdateArticleRequest, opts ...grpc.CallOption) (*UpdateArticleResponse, error)
}

type articlesDBServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewArticlesDBServiceClient(cc grpc.ClientConnInterface) ArticlesDBServiceClient {
	return &articlesDBServiceClient{cc}
}

func (c *articlesDBServiceClient) GetArticles(ctx context.Context, in *GetArticlesRequest, opts ...grpc.CallOption) (ArticlesDBService_GetArticlesClient, error) {
	stream, err := c.cc.NewStream(ctx, &ArticlesDBService_ServiceDesc.Streams[0], "/database.ArticlesDBService/GetArticles", opts...)
	if err != nil {
		return nil, err
	}
	x := &articlesDBServiceGetArticlesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type ArticlesDBService_GetArticlesClient interface {
	Recv() (*GetArticlesResponse, error)
	grpc.ClientStream
}

type articlesDBServiceGetArticlesClient struct {
	grpc.ClientStream
}

func (x *articlesDBServiceGetArticlesClient) Recv() (*GetArticlesResponse, error) {
	m := new(GetArticlesResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *articlesDBServiceClient) GetArticle(ctx context.Context, in *GetArticleRequest, opts ...grpc.CallOption) (*GetArticleResponse, error) {
	out := new(GetArticleResponse)
	err := c.cc.Invoke(ctx, "/database.ArticlesDBService/GetArticle", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *articlesDBServiceClient) CreateArticle(ctx context.Context, in *CreateArticleRequest, opts ...grpc.CallOption) (*CreateArticleResponse, error) {
	out := new(CreateArticleResponse)
	err := c.cc.Invoke(ctx, "/database.ArticlesDBService/CreateArticle", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *articlesDBServiceClient) DeleteArticle(ctx context.Context, in *DeleteArticleRequest, opts ...grpc.CallOption) (*DeleteArticleResponse, error) {
	out := new(DeleteArticleResponse)
	err := c.cc.Invoke(ctx, "/database.ArticlesDBService/DeleteArticle", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *articlesDBServiceClient) UpdateArticle(ctx context.Context, in *UpdateArticleRequest, opts ...grpc.CallOption) (*UpdateArticleResponse, error) {
	out := new(UpdateArticleResponse)
	err := c.cc.Invoke(ctx, "/database.ArticlesDBService/UpdateArticle", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ArticlesDBServiceServer is the server API for ArticlesDBService service.
// All implementations must embed UnimplementedArticlesDBServiceServer
// for forward compatibility
type ArticlesDBServiceServer interface {
	GetArticles(*GetArticlesRequest, ArticlesDBService_GetArticlesServer) error
	GetArticle(context.Context, *GetArticleRequest) (*GetArticleResponse, error)
	CreateArticle(context.Context, *CreateArticleRequest) (*CreateArticleResponse, error)
	DeleteArticle(context.Context, *DeleteArticleRequest) (*DeleteArticleResponse, error)
	UpdateArticle(context.Context, *UpdateArticleRequest) (*UpdateArticleResponse, error)
	mustEmbedUnimplementedArticlesDBServiceServer()
}

// UnimplementedArticlesDBServiceServer must be embedded to have forward compatible implementations.
type UnimplementedArticlesDBServiceServer struct {
}

func (UnimplementedArticlesDBServiceServer) GetArticles(*GetArticlesRequest, ArticlesDBService_GetArticlesServer) error {
	return status.Errorf(codes.Unimplemented, "method GetArticles not implemented")
}
func (UnimplementedArticlesDBServiceServer) GetArticle(context.Context, *GetArticleRequest) (*GetArticleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetArticle not implemented")
}
func (UnimplementedArticlesDBServiceServer) CreateArticle(context.Context, *CreateArticleRequest) (*CreateArticleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateArticle not implemented")
}
func (UnimplementedArticlesDBServiceServer) DeleteArticle(context.Context, *DeleteArticleRequest) (*DeleteArticleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteArticle not implemented")
}
func (UnimplementedArticlesDBServiceServer) UpdateArticle(context.Context, *UpdateArticleRequest) (*UpdateArticleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateArticle not implemented")
}
func (UnimplementedArticlesDBServiceServer) mustEmbedUnimplementedArticlesDBServiceServer() {}

// UnsafeArticlesDBServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ArticlesDBServiceServer will
// result in compilation errors.
type UnsafeArticlesDBServiceServer interface {
	mustEmbedUnimplementedArticlesDBServiceServer()
}

func RegisterArticlesDBServiceServer(s grpc.ServiceRegistrar, srv ArticlesDBServiceServer) {
	s.RegisterService(&ArticlesDBService_ServiceDesc, srv)
}

func _ArticlesDBService_GetArticles_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetArticlesRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ArticlesDBServiceServer).GetArticles(m, &articlesDBServiceGetArticlesServer{stream})
}

type ArticlesDBService_GetArticlesServer interface {
	Send(*GetArticlesResponse) error
	grpc.ServerStream
}

type articlesDBServiceGetArticlesServer struct {
	grpc.ServerStream
}

func (x *articlesDBServiceGetArticlesServer) Send(m *GetArticlesResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _ArticlesDBService_GetArticle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetArticleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ArticlesDBServiceServer).GetArticle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/database.ArticlesDBService/GetArticle",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ArticlesDBServiceServer).GetArticle(ctx, req.(*GetArticleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ArticlesDBService_CreateArticle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateArticleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ArticlesDBServiceServer).CreateArticle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/database.ArticlesDBService/CreateArticle",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ArticlesDBServiceServer).CreateArticle(ctx, req.(*CreateArticleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ArticlesDBService_DeleteArticle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteArticleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ArticlesDBServiceServer).DeleteArticle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/database.ArticlesDBService/DeleteArticle",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ArticlesDBServiceServer).DeleteArticle(ctx, req.(*DeleteArticleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ArticlesDBService_UpdateArticle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateArticleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ArticlesDBServiceServer).UpdateArticle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/database.ArticlesDBService/UpdateArticle",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ArticlesDBServiceServer).UpdateArticle(ctx, req.(*UpdateArticleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ArticlesDBService_ServiceDesc is the grpc.ServiceDesc for ArticlesDBService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ArticlesDBService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "database.ArticlesDBService",
	HandlerType: (*ArticlesDBServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetArticle",
			Handler:    _ArticlesDBService_GetArticle_Handler,
		},
		{
			MethodName: "CreateArticle",
			Handler:    _ArticlesDBService_CreateArticle_Handler,
		},
		{
			MethodName: "DeleteArticle",
			Handler:    _ArticlesDBService_DeleteArticle_Handler,
		},
		{
			MethodName: "UpdateArticle",
			Handler:    _ArticlesDBService_UpdateArticle_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetArticles",
			Handler:       _ArticlesDBService_GetArticles_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "pb/article_db.proto",
}
